;**  Programme SIMPLE  comprendre pour utiliser le module tpoly5.h (texture MAP)
;**  Bien sur ce programme ne preserve pas l'ecran LCD mais c pour se la jouer PC

 include "util.h"
 include "routines.h"
 include "key.h"
 include "doorsos.h"
 include "draw.h"
 include "draw_tp.h"

 xdef _main
 xdef _ti89
 xdef _comment

clipping_gauche EQU 5
clipping_droit  EQU 155
clipping_haut   EQU 5
clipping_bas    EQU 95
compteur        EQU 64

coordonnees_suivantes MACRO
;***  parametres : - coordonnees du point
;                  - sa vitesse (modifie dans le cas d'un rebond)

 lea \1,a0
 lea \2,a1

 move.l \2,d0
 add.l d0,\1       ;nouvelle postion du point

;***  Cas des rebonds:
;Rebond en haut de l'ecran
 cmpi.w #clipping_haut,2(a0)
 bgt   \1_\2_1
 neg.w 2(a1)
 move.w #clipping_haut,2(a0)

;Rebond en bas de l'ecran
\1_\2_1:
 cmpi.w #clipping_bas,2(a0)
 blt   \1_\2_2
 neg.w 2(a1)
 move.w #clipping_bas,2(a0)

;Rebond  gauche de l'ecran
\1_\2_2:
 cmpi.w #clipping_gauche,(a0)
 bgt   \1_\2_3
 neg.w (a1)
 move.w #clipping_gauche,(a0)

;Rebond  droite de l'ecran
\1_\2_3:
 cmpi.w #clipping_droit,(a0)
 blt   \1_\2_4
 neg.w (a1)
 move.w #clipping_droit,(a0)

\1_\2_4:

 ENDM

dessine_un_triangle_en_texture_map MACRO
;***  paramtres : -\1- point 1
;                  -\2- coordonnees map pour le pt 1 en Long Word
;                  -\3- point 2
;                  -\4- coord. map pour le pt 2
;                  -\5- point 3
;                  -\6- coord. map pour le pt 3

;** On definit les sommets dans le sens horaire puis dans le sens antihoraire
;   pour etre sur que le polygone sera dessin.

;1) on definit les sommets du polygone :
 lea polygone,a0
 move.w #3,(a0)+              ;le polygone a 3 sommets
 move.l \1,(a0)+
 move.l \3,(a0)+
 move.l \5,(a0)+
;2) on definit les coordonnees map du polygone :
 lea coordonnees_de_mapping,a0
 move.l \2,(a0)+
 move.l \4,(a0)+
 move.l \6,(a0)+

 movea.l adresse_de_l_ecran_virtuel,a0
 bsr dessine_map

 lea polygone,a0
 move.w #3,(a0)+              ;le polygone a 3 sommets
 move.l \3,(a0)+
 move.l \1,(a0)+
 move.l \5,(a0)+
 lea coordonnees_de_mapping,a0
 move.l \4,(a0)+
 move.l \2,(a0)+
 move.l \6,(a0)+

 movea.l adresse_de_l_ecran_virtuel,a0
 bsr dessine_map

;***  Teste si [ON] est press des que le polygone est dessine (procedure relativement longue)
 test_esc
 beq fin

 ENDM

dessine_map:
 draw_textured_polygon
 rts

_main:

  clear_interrupts
;***  alloue de la memoire pour l'ecran viruel (tampon):
  move.l #3000,d0                         ;La taille de l'cran semble faire 375 octet sur ttes TI

  cree_un_bloc_memoire_de_taille d0,ev

  move.w d0,ecran_virtuel
  doorsos::DEREF d0,a0
  move.l a0,adresse_de_l_ecran_virtuel

 clear_interrupts

;***  fin d'allocation


;********************************************************************************************
;*************************   ANIMATION  1  :    *********************************************
;********************************************************************************************
;***  Initialise la position des points au centre de l'ecran
 move.l #$00320032,pt1
 move.l #$00320032,pt2
 move.l #$006E0032,pt3
 move.l #$006E0032,pt4

 lea coordonnees_de_mapping,a0
 move.l #$00000000,(a0)+
 move.l #$0000005A,(a0)+
 move.l #$0064005A,(a0)+
 move.l #$00640000,(a0)

next_frame1:
; efface l'ecran virtuel
 move.l adresse_de_l_ecran_virtuel,a0
 move.l #749,d0
clear_screen1:
 move.l #0,(a0)+
 DBra d0,clear_screen1

;***  Position suivante des points :
 addi.l #$FFFEFFFF,pt1               ;on le deplace en haut  gauche
 addi.l #$FFFF0001,pt2               ;on le deplace en bas  gauche
 addi.l #$00010001,pt3               ;on le deplace en bas  droite
 addi.l #$0000FFFF,pt4               ;on le deplace en haut  droite

 lea polygone,a0
 move.w #4,(a0)+
 move.l pt1,(a0)+
 move.l pt2,(a0)+
 move.l pt3,(a0)+
 move.l pt4,(a0)

;***  On affiche le polygone:
 move.l adresse_de_l_ecran_virtuel,a0
 bsr dessine_map

;***  On copie pour de bon :
;... le cube 3D :
 move.l #749,d0
 move.l #LCD_MEM,a0
 move.l adresse_de_l_ecran_virtuel,a1
copie_sur_ecran1:
 move.l (a1)+,(a0)+
 DBra d0,copie_sur_ecran1

 cmpi.w #clipping_gauche,pt1
 bne next_frame1

;********************************************************************************************
;*************************   ANIMATION  2  :    *********************************************
;********************************************************************************************
;***  Initialise la valeur des points :
anim2:

 move.l #$00000000,pt1
 move.l #$00000064,pt2
 move.l #$00A00064,pt3
 move.l #$00A00000,pt4

 move.l #$00000000,pt5
 move.l #$00000064,pt6
 move.l #$00A00064,pt7
 move.l #$00A00000,pt8

 move.l #$00500032,pt9
 move.l #$00500032,pt0

 clr.b frames

next_frame2:

; efface l'ecran virtuel
 move.l adresse_de_l_ecran_virtuel,a0
 move.l #749,d0
clear_screen2:
 move.l #0,(a0)+
 DBra d0,clear_screen2

;***  Trajectoires suivantes pour chacun des points:

 coordonnees_suivantes pt4,v4
 coordonnees_suivantes pt5,v5
 coordonnees_suivantes pt6,v6
 coordonnees_suivantes pt7,v7
 coordonnees_suivantes pt8,v8
 coordonnees_suivantes pt9,v9
 coordonnees_suivantes pt0,v0

;***  Dessine les triangles :
 dessine_un_triangle_en_texture_map pt4,#$00640000,pt5,#$00000000,pt9,#$0032002D
 dessine_un_triangle_en_texture_map pt7,#$0064005A,pt8,#$00640000,pt0,#$0032002D

;***  Dessine le logo tournant a depasse le nbre d'image a atteint compteur.
 addq.b #1,frames
 cmpi.b #compteur,frames
 blt    no_logo
;cas du dessin du logo :

 lea coordonnees_de_mapping,a0
 move.l #$00000000,(a0)+
 move.l #$0000005A,(a0)+
 move.l #$0064005A,(a0)+
 move.l #$00640000,(a0)

 lea polygone,a0
 move.w #4,(a0)+
 move.l a0,a2                ;sauve la position de a2 pour usage ulterieur (*)

 lea sinus,a1
 move.b frames,d0
 asl.w  #1,d0
 andi.l #255,d0              ;modulo 128 avec masquage du premier bit (pour un adresse paire)
 adda.l d0,a1                ;a1 pointe sur le sinus courant
;a0 pointe sur le sinus de l'angle du logo
 move.w (a1),d4
 muls   (a1),d4
 asr.l #8,d4                 ;sin  => d4
 move.w d4,d5
 neg.w d5                    ;-sin => d5
 move.w 64(a1),d6
 muls   (a1),d6
 asr.l #8,d6                 ;cos  => d6
 move.w d6,d7
 neg.w d7                    ;-cos => d7

 move.w d6,d0
 asl.l #8,d0
 asl.l #8,d0
 move.w d4,d0

 move.w d5,d1
 asl.l #8,d1
 asl.l #8,d1
 move.w d6,d1

 move.w d7,d2
 asl.l #8,d2
 asl.l #8,d2
 move.w d5,d2

 move.w d4,d3
 asl.l #8,d3
 asl.l #8,d3
 move.w d7,d3

 add.l #$00500032,d0        ;centre le logo koi
 add.l #$00500032,d1
 add.l #$00500032,d2
 add.l #$00500032,d3

 move.l d2,(a0)+
 move.l d1,(a0)+
 move.l d0,(a0)+
 move.l d3,(a0)

 move.l adresse_de_l_ecran_virtuel,a0
 bsr dessine_map

 test_esc
 beq fin

 jmp if_logo

no_logo:

;*** Ce triangle n'est pas affiche avec le logo pour soulager le CPU

 coordonnees_suivantes pt1,v1
 coordonnees_suivantes pt2,v2
 coordonnees_suivantes pt3,v3
 dessine_un_triangle_en_texture_map pt1,#$00000000,pt2,#$0000005A,pt3,#$0064005A


if_logo:

;***  On copie pour de bon :
;... le cube 3D :
 move.l #749,d0
 move.l #LCD_MEM,a0
 move.l adresse_de_l_ecran_virtuel,a1
copie_sur_ecran2:
 move.l (a1)+,(a0)+
 DBra d0,copie_sur_ecran2

 jmp next_frame2

fin:

 supprime_le_handle_memoire ecran_virtuel
 restore_interrupts

 rts

;***  Compte le nbre d'images :
frames: dc.b 0

;***  Coordonnes des points :
; Le Hi Word est l'abscisse
; Le Low Word est l'ordonne
pt1: dc.l 0
pt2: dc.l 0
pt3: dc.l 0
pt4: dc.l 0
pt5: dc.l 0
pt6: dc.l 0
pt7: dc.l 0
pt8: dc.l 0
pt9: dc.l 0
pt0: dc.l 0

;***  Vitesse des points respectifs ki se deplacent;
;***  le Hi word correspond a la vitesse sur x (le Low sur y)
;     En additionnant les coordonnees aux 'vitesses' tout revient dans l'ordre

v1: dc.l $00010002
v2: dc.l $00020002
v3: dc.l $00020001
v4: dc.l $00020005

v5: dc.l $00020001
v6: dc.l $00030003
v7: dc.l $00010003
v8: dc.l $00040002

v9: dc.l $00020001
v0: dc.l $00020003

coordonnees_de_mapping: dc.w 0,0,0,90,100,90,100,0,0  ;valeur biddons pour reserver de la memoire
polygone: dc.w 3                          ;nbre de pts ki definissent le polygone
          dc.w 0,0,0,90,150,90,0,0        ;chiffre pipot pour reserver de la memoire


largeur_de_l_image EQU 100

image: incbin "image.raw"

;***  handle pour l'cran virtuel
ecran_virtuel: dc.w 0
adresse_de_l_ecran_virtuel: dc.l 0

;***  Table des sinus :
sinus: dc.w 0,6,13,19,25,31,37,43,49,55,60,66,71,76,81,86,91,95,99,103,106,110,113,116,118,121,
       dc.w 122,124,126,127,127,128,128,128,127,127,126,124,122,121,118,116,113,110,106,103,99,
       dc.w 95,91,86,81,76,71,66,60,55,49,43,37,31,25,19,13,6,0,-6,-13,-19,-25,-31,-37,-43,-49,
       dc.w -55,-60,-66,-71,-76,-81,-86,-91,-95,-99,-103,-106,-110,-113,-116,-118,-121,-122,-124,
       dc.w -126,-127,-127,-128,-128,-128,-127,-127,-126,-124,-122,-121,-118,-116,-113,-110,-106,
       dc.w -103,-99,-95,-91,-86,-81,-76,-71,-66,-60,-55,-49,-43,-37,-31,-25,-19,-13,-6,0,6,13,
       dc.w 19,25,31,37,43,49,55,60,66,71,76,81,86,91,95,99,103,106,110,113,116,118,121,122,124,
       dc.w 126,127,127,128,128,128

_comment: dc.b "pseudo-'economisateur d'ecran'",0

 END